// DirectStreamDlg.cpp : implementation file
//

#include "stdafx.h"
#include "afxctl.h"
#include <string>

#include "DirectStream.h"
#include "DirectStreamDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int ID_TIMER1 = 100;
CDirectStreamDlg* gDialog = NULL;

using namespace std; 

/////////////////////////////////////////////////////////////////////////////
// CDirectStreamDlg dialog

CDirectStreamDlg::CDirectStreamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDirectStreamDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDirectStreamDlg)
	m_ServerPort = _T("");
	m_ClientPort = _T("");
	m_Host = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDirectStreamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDirectStreamDlg)
	DDX_Control(pDX, IDC_COMBO4, m_Codec);
	DDX_Control(pDX, IDC_COMBO3, m_SamplingRate);
	DDX_Control(pDX, IDC_COMBO5, m_InDevice);
	DDX_Control(pDX, IDC_COMBO6, m_OutDevice);
	DDX_Control(pDX, IDC_COMBO2, m_ClientSocketType);
	DDX_Control(pDX, IDC_COMBO1, m_ServerSocketType);
	DDX_Control(pDX, IDC_BUTTON4, m_ClientStop);
	DDX_Control(pDX, IDC_BUTTON3, m_ClientStart);
	DDX_Control(pDX, IDC_BUTTON2, m_ServerStop);
	DDX_Control(pDX, IDC_BUTTON1, m_ServerStart);
	DDX_Text(pDX, IDC_EDIT1, m_ServerPort);
	DDX_Text(pDX, IDC_EDIT2, m_ClientPort);
	DDX_Text(pDX, IDC_EDIT3, m_Host);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDirectStreamDlg, CDialog)
	//{{AFX_MSG_MAP(CDirectStreamDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDirectStreamDlg message handlers

BOOL CDirectStreamDlg::OnInitDialog()
{
	gDialog = this;
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_ServerSocketType.AddString(_T("TCP"));
	m_ServerSocketType.AddString(_T("UDP"));
	m_ServerSocketType.SetCurSel(0);

	m_ClientSocketType.AddString(_T("TCP"));
	m_ClientSocketType.AddString(_T("UDP"));
	m_ClientSocketType.SetCurSel(1);

	m_Codec.AddString(_T("1 (PCM)"));
	m_Codec.AddString(_T("2 (ADPCM)"));
	m_Codec.AddString(_T("6 (a-Law)"));
	m_Codec.AddString(_T("7 (u-Law)"));
	m_Codec.AddString(_T("49 (GSM)"));
	m_Codec.AddString(_T("85 (MP3)"));
	m_Codec.SetCurSel(0);

	m_SamplingRate.AddString(_T("8000"));
	m_SamplingRate.AddString(_T("11025"));
	m_SamplingRate.AddString(_T("16000"));
	m_SamplingRate.AddString(_T("22050"));
	m_SamplingRate.AddString(_T("24000"));
	m_SamplingRate.AddString(_T("32000"));
	m_SamplingRate.AddString(_T("44100"));
	m_SamplingRate.SetCurSel(0);

	m_ServerPort = _T("2020");
	m_ClientPort = _T("3030");
	m_Host = _T("192.168.1.1");

	UpdateData(false);
	VCInit();

	for (int i = 0; i < m_WaveIn->GetDeviceCount(); i++)
		m_InDevice.AddString(m_WaveIn->GetDeviceName(i));
	m_InDevice.SetCurSel(0);

	for (i = 0; i < m_WaveOut->GetDeviceCount(); i++)
		m_OutDevice.AddString(m_WaveOut->GetDeviceName(i));
	m_OutDevice.SetCurSel(0);

	SetTimer(ID_TIMER1, 500, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDirectStreamDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CDirectStreamDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDirectStreamDlg::OnClose() 
{
	KillTimer(ID_TIMER1);
	VCUninit();	
	CDialog::OnClose();
}

void CDirectStreamDlg::VCInit()
{
	m_IpServer.CreateInstanceLic(__uuidof(vcproIpServerX), L"0");
	m_Codec2.CreateInstanceLic(__uuidof(vcproWaveCodecDeviceX), L"0");
	m_WaveOut.CreateInstanceLic(__uuidof(vcproWaveOutDeviceX), L"0");
	
	m_WaveIn.CreateInstanceLic(__uuidof(vcproWaveInDeviceX), L"0");
	m_Codec1.CreateInstanceLic(__uuidof(vcproWaveCodecDeviceX), L"0");
	m_IpClient.CreateInstanceLic(__uuidof(vcproIpClientX), L"0");

	// server

	m_IpServer->StreamingMode = unapt_RAW;
	m_IpServer->IsFormatProvider = false;

	m_Codec2->FormatTagImmunable = false;
	m_Codec2->InputIsPcm = false;
	m_Codec2->PcmNumChannels = 1;

	// client

	m_WaveIn->PcmNumChannels = 1;

	m_Codec1->PcmNumChannels = 1;

	m_IpClient->StreamingMode = unapt_RAW;

	// link components together
	SetLink(m_IpServer, m_Codec2);
	SetLink(m_Codec2, m_WaveOut);

	SetLink(m_WaveIn, m_Codec1);
	SetLink(m_Codec1, m_IpClient);
}

void CDirectStreamDlg::VCUninit()
{
	ClientInit(false);
	ServerInit(false);
}

void CDirectStreamDlg::SetLink(IvcproProviderPtr provider, IvcproConsumerPtr consumer)
{
	provider->AddConsumer(consumer);
}

void CDirectStreamDlg::ServerInit(bool bStart)
{
	if (bStart) {
		UpdateData();
		BSTR port = m_ServerPort.AllocSysString();
		m_IpServer->Port = port;
		SysFreeString(port);

		m_IpServer->Proto =
			static_cast<unaProtoType>(m_ServerSocketType.GetCurSel());

		m_Codec2->PcmSamplesPerSec = SamplingRate(m_SamplingRate);
		m_Codec2->FormatTag = FormatTag(m_Codec);

		m_WaveOut->DeviceId = m_OutDevice.GetCurSel();
	}

	m_IpServer->Active = bStart;
}

void CDirectStreamDlg::ClientInit(bool bStart)
{
	if (bStart) {
		UpdateData();
		BSTR port = m_ClientPort.AllocSysString();
		BSTR host = m_Host.AllocSysString();
		m_IpClient->Port = port;
		m_IpClient->Host = host;
		SysFreeString(port);
		SysFreeString(host);

		m_IpClient->Proto =
			static_cast<unaProtoType>(m_ClientSocketType.GetCurSel());

		m_WaveIn->DeviceId = m_InDevice.GetCurSel();
		m_WaveIn->PcmSamplesPerSec = SamplingRate(m_SamplingRate);

		m_Codec1->FormatTag = FormatTag(m_Codec);
	}

	m_WaveIn->Active = bStart;
}

int CDirectStreamDlg::SamplingRate(CComboBox& combo) {

	switch (combo.GetCurSel()) {
		case 1: return 11025;
		case 2: return 16000;
		case 3: return 22050;
		case 4: return 24000;
		case 5: return 32000;
		case 6: return 44100;
		default: return 8000;
	}
}

int CDirectStreamDlg::FormatTag(CComboBox& combo)
{
	switch (combo.GetCurSel()) {
		case 1: return 2;
		case 2: return 6;
		case 3: return 7;
		case 4: return 49;
		case 5: return 85;
		default: return 1;
	}
}

void CDirectStreamDlg::OnButton1() { ServerInit(); }

void CDirectStreamDlg::OnButton2() { ServerInit(false); }

void CDirectStreamDlg::OnButton3() { ClientInit(); }

void CDirectStreamDlg::OnButton4() { ClientInit(false); }

void CDirectStreamDlg::OnTimer(UINT nIDEvent)
{
	int serverActive = m_IpServer->Active;
	int clientActive = m_IpClient->Active;

	m_ServerStart.EnableWindow(!serverActive);
	m_ServerStop.EnableWindow(serverActive);
	m_ClientStart.EnableWindow(!clientActive);
	m_ClientStop.EnableWindow(clientActive);

	char buffer[10];
	itoa(m_IpServer->BytesReceived, buffer, 10);
	string serverSizeIn(string("bytes received: ") + string(buffer));
	itoa(m_IpServer->BytesSent, buffer, 10);
	string serverSizeOut(string("bytes sent: ") + string(buffer));
	itoa(m_IpClient->BytesReceived, buffer, 10);
	string clientSizeIn(string("bytes received: ") + string(buffer));
	itoa(m_IpClient->BytesSent, buffer, 10);
	string clientSizeOut(string("bytes sent: ") + string(buffer));

	CWnd* pWnd;
	pWnd = GetDlgItem(IDC_STATIC1);
	pWnd->SetWindowText(serverSizeIn.c_str());
	pWnd = GetDlgItem(IDC_STATIC2);
	pWnd->SetWindowText(serverSizeOut.c_str());
	pWnd = GetDlgItem(IDC_STATIC3);
	pWnd->SetWindowText(clientSizeIn.c_str());
	pWnd = GetDlgItem(IDC_STATIC4);
	pWnd->SetWindowText(clientSizeOut.c_str());

	CDialog::OnTimer(nIDEvent);
}

void CDirectStreamDlg::OnButton5() 
{
	char buffer[5];
	itoa(m_WaveIn->GetMixerId(m_InDevice.GetCurSel(), true), buffer, 10);
	string params = "/r /d" + string(buffer);
	ShellExecute(NULL, "open", "sndvol32", params.c_str(), NULL, SW_SHOW);
}

void CDirectStreamDlg::OnButton6() 
{
	char buffer[5];
	itoa(m_WaveOut->GetMixerId(m_OutDevice.GetCurSel(), false), buffer, 10);
	string params = "/p /d" + string(buffer);
	ShellExecute(NULL, "open", "sndvol32", params.c_str(), NULL, SW_SHOW);
}
